<template>
  <div>
    <Row>
      <!--查询-->
      <Col span="28" />
      <Form
        v-show="searchOpen"
        inline
        onsubmit="return false"
        :label-width="70"
        class="search-form"
      >
        <label class="label-sign" />
        <Form-item class="search-item" label=" 耗材名称:">
          <Input v-model="formObj.chemicalName" placeholder="请输入耗材名称" @on-enter="_formSearch" /></Input>
        </Form-item>
        <Form-item class="search-btn">
          <Button type="primary" @click="_formSearch">
            搜索
          </Button>
        </Form-item>
      </Form>
      </Col>
      <!--按钮-->
      <Col span="24" />
      <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />
      </Col>
      <!--table-->
      <Col span="24" />
      <element-table
        ref="pageTable"
        :page-columns="pageColumns"
        :table-height="tableHeight"
        :get-page="getPage"
        click="true"
        show-check-box
        :opt-col-width="80"
        @on-result-change="_tableResultChange"
      >
        <el-table-column
          v-for="item in pageColumns"
          :key="item.key"
          show-overflow-tooltip
          sortable
          :prop="item.key"
          :label="item.title"
          :width="item.width"
          :min-width="200"
          :fixed="item.fixed?item.fixed:undefined"
        >
          <template slot-scope="scope">
            <div v-if="item.dateTime">
              {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):'' }}
            </div>
            <span v-else-if="item.type" class="blue-color">
              {{ scope.row[item.key] === undefined ? '': scope.row[item.key].display }}
            </span>
            <div v-else>
              {{ scope.row[item.key] }}
            </div>
          </template>
        </el-table-column>
      </element-table>
      </Col>
    </Row>
  </div>
</template>
<script>
import { consumeRelPurchase } from '../../../../api'
export default {
  components: {},
  data() {
    return {
      formObj: {
        name: '',
        sampleCode: '',
        orderId: ''
      },
      selectData: [],
      searchOpen: true,
      btn: [
        // { type: 'success', id: '', name: '自动分配' }
      ],
      pageColumns: [
        { title: '编号', width: 120, key: 'chemicalNum', fixed: 'left' },
        { title: '耗材名称', key: 'chemicalName', width: 150 },
        { title: '状态', key: 'stateDisplay', width: 120 },
        { title: '单价', key: 'price', width: 100 },
        { title: '采购量', key: 'quantity', width: 100 },
        { title: '已入库数量', key: 'alreadyQuantity', width: 130 },
        { title: '计量单位', key: 'unit', width: 100 },
        { title: '规格', key: 'spec', width: 100 },
        { title: '等级（纯度）', key: 'quality', width: 120 },
        { title: '供应商', width: 120, key: 'supplier' },
        { title: '制造厂商', key: 'manufacturer', width: 200 },
        { title: '备注', key: 'remark' }
      ],
      getPage: {},
      iconMsg: [
        // { type: 'pt-a-edit', id: '', name: '编辑' },
        // { type: 'pt-a-trash', id: '', name: '删除' }
      ],
      iconMsgDis: [
        { type: 'pt-a-edit', id: '', name: '编辑' },
        { type: 'pt-a-trash', id: '', name: '删除', disabled: true }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search') - 60
      } else {
        return this.$tableHeight('noSearch') - 60
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function(data) {
      this.getPage.records = []
      if (data === undefined || undefined === data.id) {
        this.getPage = []
        this.$refs.pageTable._initTable()
        return false
      }
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      this.orderId = data.id
      const result = await consumeRelPurchase.pageByBuyOrder(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _searchParams(formId) {
      return this.$refs.pageTable._searchParams(formId)
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'click':
          this.$emit('on-result-change', data)
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data.id)
          break
        case '删除':
          this._deleteById(data.id)
          break
      }
    },
    _open() {
      this._page()
    },
    // 删除
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该信息？',
        onOk: () => {
          this._delOk(id)
        }
      })
    },
    _delOk: async function(id) {
      const result = await consumeRelPurchase.deleteById(id)
      if (result) {
        this.$Message.success('删除成功')
        this._page()
      }
    },
    _editModal: async function(id) {
      const result = await consumeRelPurchase.getById(id)
      if (result) {
        this.$refs.editModal._open(result)
      }
    }
  }
}
</script>
